<template>
  <q-page class="column items-center justify-center">
    <!--<q-img class="logo" src="logo.svg" /> -->
    <div class="top-left-menu column justify-around"></div>
    <div class="top-right-menu">
      <div class="row items-center justify-evenly">
        <remote-vue :ready="isReady" @play="handlePlay" @stop="handleStop" :running="options.isRunning" />
        <q-btn push round text-color="primary" icon="mdi-chart-bell-curve-cumulative" @click="handleOpenPlot" size="md" />
        <q-btn push round text-color="primary" icon="search" @click="showQueue = true" size="md" />
      </div>
    </div>
    <div class="col-12 column" style="margin-top: 10em; padding: 100px">
      <div class="col row no-wrap justify-center" style="width: 100%">
        <block
          v-for="b in experiment.blocks"
          :key="'block:' + b.id"
          :block="b"
          :options="options"
          @clear="handleClear(b.id)"
          @pick="handlePick(b.id)"
          @update:loopMap="handleLoopMap(b, ...$event)"
          @selected="handleSelected"
          @delete="handleDelete(b.id)"
        />
        <div class="col row justify-center items-center">
          <q-btn
            push
            size="32px"
            round
            color="white"
            text-color="black"
            icon="add"
            @click="handleAddBlock"
            style="margin-left: 36px"
            :disable="options.isRunning"
          />
        </div>
      </div>
    </div>
    <div class="items-center justify-center" style="width: 25em; position: absolute; top: 128px">
      <!--       <q-linear-progress :value="progressBar" size="lg" style="margin: 4em" /> -->
      <q-input filled hide-hint hint="Experiment name" v-model="experimentName" :readonly="options.isRunning">
        <template v-slot:append>
          <q-icon name="edit" />
        </template>
      </q-input>
      <!--       <div class="col-8 text-h6" style="margin-top: 60px">{{ progress }}</div> -->
    </div>

    <queue-dialog-vue v-model:show="showQueue" :experiment="experiment" />
  </q-page>
</template>

<script lang="ts">
import Block from 'components/experiment/Block.vue';
import QueueDialogVue from 'components/experiment/QueueDialog.vue';
import RemoteVue from 'components/experiment/Remote.vue';
import { defineComponent, reactive, computed, ref } from 'vue';
import { ExperimentBlock, ExperimentBlockUpdate, ExperimentOptions, TaskLoopMap } from 'src/models/experiment';
import { useRouter } from 'vue-router';
import { createBlock } from 'src/components/experiment/block';
import { buildQueue } from 'components/experiment/block';
import { useStore } from 'src/store';
import { ExperimentHandler } from 'components/experiment/experiment';
import { RefinedTask } from 'src/models/workflow';

export default defineComponent({
  components: {
    Block,
    RemoteVue,
    QueueDialogVue,
  },
  setup() {
    const $store = useStore();
    const experimentStore = $store.state.experiment;
    const $router = useRouter();
    const options = reactive({
      selected: '',
      isRunning: false,
    } as ExperimentOptions);

    const showQueue = ref(false);

    const experimentHandler = new ExperimentHandler();
    const experimentName = ref('default');
    const experiment = computed(() => experimentStore.currentExperiment);

    const queueLength = computed(() =>
      experiment.value.blocks.reduce((partialSum, currentBlock) => partialSum + currentBlock.queue.length, 0)
    );
    const progressBar = computed(() => (currentQueueIndex.value + 1) / queueLength.value);
    const progress = computed(() =>
      options.isRunning ? `Running task ${currentQueueIndex.value + 1} of ${queueLength.value}` : 'Not running'
    );

    const isReady = computed(() => {
      return (
        experiment.value.blocks.filter((block) => block.queue.length === 0).length === 0 &&
        experiment.value.blocks.length > 0
      );
    });

    const currentQueueIndex = ref(-1);

    const handleAddBlock = () => {
      const block = createBlock();
      $store.commit('experiment/addBlock', block);
    };

    const handleClear = (id: string) => {
      updateBlock({ id: id, template: null, loopMap: null, queue: [] });
    };

    const handleSelected = (id: string) => {
      options.selected = id;
    };

    const handlePick = (id: string) => {
      $store.commit('experiment/setEditingBlock', id);
      void $router.push('/experiment/task');
    };

    const handleDelete = (id: string) => {
      $store.commit('experiment/removeBlock', id);
    };

    const updateBlock = (update: ExperimentBlockUpdate) => {
      $store.commit('experiment/updateBlock', update);
    };

    const handleLoopMap = (block: ExperimentBlock, value: TaskLoopMap, loopMode: string) => {
      updateBlock({ id: block.id, loopMap: value });
      const updatedBlock = experimentStore.currentExperiment.blocks.find((bblock) => bblock.id === block.id);
      if (updatedBlock) updateBlock({ id: updatedBlock.id, queue: buildQueue(updatedBlock, loopMode) });
    };

    const handlePlay = () => {
      reset();
      experiment.value.blocks.forEach((block) => {
        updateBlock({ id: block.id, currentTime: 0, currentIteration: 0 });
      });
      let queue: Array<RefinedTask> = [];
      for (const block of JSON.parse(JSON.stringify(experiment.value.blocks)) as Array<ExperimentBlock>) {
        queue = queue.concat([...block.queue]);
      }
      experimentHandler.load(queue);
      currentQueueIndex.value = 0;

      experimentHandler.on('next', (index: number) => {
        currentQueueIndex.value = index;
      });
      experimentHandler.on('finish', () => {
        options.isRunning = false;
        reset();
      });
      experimentHandler.on('start', () => {
        options.isRunning = true;
      });
      experimentHandler.run(experimentName.value);
    };

    const handleStop = () => {
      experimentHandler.stop();
    };

    const reset = () => {
      currentQueueIndex.value = -1;
    };

    const handleOpenPlot = () => {
      void window.openWindow.plot();
    };

    return {
      options,
      handleClear,
      handleAddBlock,
      handleSelected,
      handleDelete,
      handlePick,
      handleOpenPlot,
      experiment,
      handleLoopMap,
      handlePlay,
      handleStop,
      experimentName,
      queueLength,
      progress,
      progressBar,
      isReady,
      showQueue,
    };
  },
});
</script>

<style lang="sass" scoped>

.top-right-menu
  position: absolute
  top: 32px
  right: 64px
  min-width: 250px

.top-left-menu
  position: absolute
  height: 250px
  width: 250px
  top: 32px
  left: 32px
</style>
